<?php

//
//  Copyright : IceWarp France / DARNIS Informatique
//  Date : décembre 2019
//  Description : Programme pour exporter les droits Groupware au format texte
//  			  Le contenu complet de la table FolderRights est exporté
//				  Si exécuté dans un navigateur, la liste complète des droits s'affiche dans le navigateur et un email est envoyé à l'adresse configurée
//                Si exécuté en tant que tâche planifiée, un email est envoyé à l'adresse configurée - avec la liste des droits dans le corps et en pièce //                  jointe            
//  Pre-requis : -  

//  Usage : Sauvegarder ce fichier PHP dans le répertoire 'html' de l'intallation d'IceWarp (ou dans un sous-répertoire)
//          Editer ce fichier pour modifier les identifiants de la connexion MySQL  (lignes 48 et 102)
//          Editer ce fichier pour modifier l'email et le nom du destinataire du mail d'avertissement (ligne 159)
//          Editer ce fichier pour modifier l'email et le nom de l'expéditeur du mail d'avertissement (lignes 28-30)
//          Pour tester, exécuter le programme depuis un navigateur : http(s)://<server>:<port>/folderrights.php
//			Il faut valider si besoin l'extension mysqlini dans php.ini
//          Ensuite, planifier son exécution en tant que tâche planifiée si besoin


function envoiMail($mailDestinataire, $name, $objet, $corps, $attachment) {
	$mailer = icewarp_apiobjectcall(0, '', 'IceWarpServer.Mailer');
	if (!$mailer) {
		echo "Mailer object could not be created";
		return;
	}
	icewarp_apiobjectcall( $mailer, 'Set_RemoteHost', '127.0.0.1' );
	icewarp_apiobjectcall( $mailer, 'Set_Helo', '127.0.0.1' );
	icewarp_apiobjectcall( $mailer, 'Set_MailFrom', 'support@iwdemo.fr' );
	icewarp_apiobjectcall( $mailer, 'Set_FromName', 'Support IceWarp' );
	icewarp_apiobjectcall( $mailer, 'Set_FromAddress', 'support@iwdemo.fr' );
	
	icewarp_apiobjectcall( $mailer, 'Set_Subject', $objet );
	icewarp_apiobjectcall( $mailer, 'Set_BodyText', $corps );
	
	if (!$name) $name =  $mailDestinataire;
	icewarp_apiobjectcall( $mailer, 'AddAddress', $mailDestinataire, $name );
	
	icewarp_apiobjectcall( $mailer, 'AddAttachment', $attachment );
	
	$errorCode = icewarp_apiobjectcall( $mailer, 'SendMail' );
	icewarp_apiobjectcall( $mailer, 'Reset');
	$mailer = NULL;
	
	return $errorCode ;
}

function get_group_user ($grpID) {
	$connection = new mysqli("127.0.0.1", "cpte", "mdp", "bdd");
	if ($connection->connect_errno) {
		echo("Echec lors de la connexion à MySQL : " . $connection->connect_error);
	}
	else {
		$sql = "SELECT Own_Email FROM EventGroup, EventOwner WHERE GRP_ID = '$grpID' AND OWN_ID = GRPOWN_ID";
		if (!$result = $connection->query($sql)) {
			echo("Erreur dans la query" . $connection->error);
		}
		else {
			$result->data_seek(0);
			while ($row = $result->fetch_assoc()) {
				$user=$row['Own_Email'];
			}
		}
	}
	$result->free();
	mysqli_close($connection);
	return $user;
}

function findTwoscomplement($str) 
{ 
    $n = strlen($str); 
  
    // Traverse the string to get first 
    // '1' from the last of string 
    $i; 
    for ($i = $n-1 ; $i >= 0 ; $i--) 
        if ($str[$i] == '1') 
            break; 
  
    // If there exists no '1' concatenate 
    // 1 at the starting of string 
    if ($i == -1) 
        return '1' + $str; 
  
    // Continue traversal after the  
    // position of first '1' 
    for ($k = $i-1 ; $k >= 0; $k--) 
    { 
        // Just flip the values 
        if ($str[$k] == '1') 
            $str[$k] = '0'; 
        else
            $str[$k] = '1'; 
    } 
  
    // return the modified string 
    return $str;; 
} 

### Main

$connection = new mysqli("127.0.0.1", "cpte", "mdp", "bdd");

if ($connection->connect_errno) {
    echo("Echec lors de la connexion à MySQL : " . $connection->connect_error);
}
else {
    $sql = "SELECT * from FolderRights order by FrtEmail";
    if (!$result = $connection->query($sql)) {
        echo("Erreur dans la query" . $connection->error);
    }
    else {
        $result->data_seek(0);
		$output='';
        while ($row = $result->fetch_assoc()) {
			if ($row['FrtEmail'] != '') $output .= "'".$row['FrtEmail']."' a les droits ";
			else continue;
			
			if ($row['FrtRight'] != '') $twoscomplement = findTwoscomplement(decbin(-$row['FrtRight']));
			$binaryrights = str_split($twoscomplement);
			$rights = 'Element :';
			if ($binaryrights[24] == '1') $rights .= ' lire,';
			if ($binaryrights[29] == '1') $rights .= ' écrire,';
			if ($binaryrights[26] == '1') $rights .= ' modifier,';
			if ($binaryrights[27] == '1') $rights .= ' supprimer,';
			
			$rights .= ';Dossier :';
			if ($binaryrights[25] == '1') $rights .= ' lire,';
			if ($binaryrights[23] == '1') $rights .= ' écrire,';
			if ($binaryrights[22] == '1') $rights .= ' supprimer,';
			
			$rights .= ';Administrateur:';
			if ($binaryrights[28] == '1') $rights .= ' administrer';
			$output .= "'".$rights."'";
			
			if ($row['FRTFDR_ID'] != '') $output .= " sur le dossier '".$row['FRTFDR_ID']."'";
			else $output .=  ' sur le dossier racine';
			
			$user = get_group_user ($row['FRTGRP_ID']);
			if ($row['FRTGRP_ID'] != '') $output .= " du compte '".$user."'";
			else continue;	
			
			$output .= "\n";
			//echo $output;
        }
    }
}
$result->free();
mysqli_close($connection);

//echo $output;
$fichierResultat = 'C:\Users\utilisateur\Desktop\Droits-'.date("Y-m-d-His").'.txt';
//echo $fichierResultat;
if (file_put_contents($fichierResultat, $output))
	echo 'Fichier '.$fichierResultat.' créé</BR>';
else
	echo 'Erreur écriture fichier '.$fichierResultat.'</BR>';

if ($output != '') {
	$res=envoiMail("admin@iwdemo.fr", "Support IceWarp", "Etat des droits au ".date('Y-m-d-His'), $output, $fichierResultat);
	unlink ($fichierResultat);
}

?>
